#include <ScreenCapture.au3> ;-- Required for _screencapture_capture function
#include <process.au3>
#Include <Constants.au3>
#NoTrayIcon

Opt("TrayMenuMode",1)   ; Default tray menu items (Script Paused/Exit) will not be shown.

$settingsitem   = TrayCreateItem("Edit Settings")
$settingshelp   = TrayCreateItem("Settings Help")
TrayCreateItem("")
$aboutitem      = TrayCreateItem("About")
$aboutmsg = "Delayed Capture v1.0" & @CRLF & _
"Time-Lapse screen capture software" & @CRLF & @CRLF & _
"Created by Radley Sustaire (radleygh@gmail.com)" & @CRLF & @CRLF & _
"Find this and other free, open source tools at" & @CRLF & _
"www.radgh.com" & @CRLF & @CRLF & _
"Created using AutoIt v3 - www.autoitscript.com"
TrayCreateItem("")
$exititem       = TrayCreateItem("Exit")

TraySetState()
;-- End Tray Menu

;-- Make sure the settings are loaded, and legit
	if Not FileExists(@scriptdir & "\settings.ini") then 
		INIWrite(@scriptdir & "\settings.ini","settings", "delay", "60")
		INIWrite(@scriptdir & "\settings.ini","settings", "type", "jpg")
		INIWrite(@scriptdir & "\settings.ini","settings", "name", "screen_")
		INIWrite(@scriptdir & "\settings.ini","settings", "location", @scriptdir & "\images\")
		INIWrite(@scriptdir & "\settings.ini","settings", "jpg quality", "80")
		INIWrite(@scriptdir & "\settings.ini","settings", "bmp format", "2")
		INIWrite(@scriptdir & "\settings.ini","settings", "region_x1", "0")
		INIWrite(@scriptdir & "\settings.ini","settings", "region_y1", "0")
		INIWrite(@scriptdir & "\settings.ini","settings", "region_x2", "-1")
		INIWrite(@scriptdir & "\settings.ini","settings", "region_y2", "-1")
		INIWrite(@scriptdir & "\settings.ini","settings", "capture mouse", "1")
	EndIf

	$delay = iniread(@scriptdir & "\settings.ini", "settings", "delay", 60)
		if $delay < 1 then $delay = 1
			
	$format = iniread(@scriptdir & "\settings.ini", "settings", "type", "jpg")
		if stringlower($format) <> "jpg" OR stringlower($format) <> "bmp" OR stringlower($format) <> "png" OR stringlower($format) <> "gif" then $format = "jpg"
	#cs
		BMP is lossless, but very large (4,000KB)
		PNG has the second best quality and very small (141KB)
		JPG is also small but loses some quality (386KB)
		GIF is horrible quality but is the smallest (85KB)
	#ce

	$filename = iniread(@scriptdir & "\settings.ini", "settings", "name", "screen_")

	$Location = iniread(@scriptdir & "\settings.ini", "settings", "location", @scriptdir & "\images\")
	if StringRight($location,1) <> "\" then $Location = $Location & "\"
		
	$jpgquality = iniread(@scriptdir & "\settings.ini", "settings", "jpg quality", "80")
	if Not IsInt($jpgquality) then Int($jpgquality)
	if $jpgquality < 10 then $jpgquality = 10
	if $jpgquality > 100 then $jpgquality = 100
	$bmpformat = iniread(@scriptdir & "\settings.ini", "settings", "bmp format", "2")
	if Not IsInt($bmpformat) then Int($bmpformat)
	if $bmpformat < 0 then $bmpformat = 0
	if $bmpformat > 4 then $bmpformat = 4
	_ScreenCapture_SetJPGQuality($jpgquality)
	_ScreenCapture_SetBMPFormat($bmpformat)

	dim $region[4]
	$region[0] = iniread(@scriptdir & "\settings.ini", "settings", "region_x1", "0")
	$region[1] = iniread(@scriptdir & "\settings.ini", "settings", "region_y1", "0")
	$region[2] = iniread(@scriptdir & "\settings.ini", "settings", "region_x2", "-1")
	$region[3] = iniread(@scriptdir & "\settings.ini", "settings", "region_y2", "-1")
	$capturemouse = iniread(@scriptdir & "\settings.ini", "settings", "capture mouse", "1")
;-- End settings

$index = 0

AdLibEnable("takeScreenshots", $delay * 1000) ;-- Runs this function every X seconds (milliseconds without the *1000)

While 1
    $msg = TrayGetMsg()
    Select
		Case $msg = 0
			continueloop
		Case $msg = $settingsitem
            ShellExecute(@WindowsDir & "\notepad.exe", @scriptdir & "\settings.ini")
		Case $msg = $settingshelp
            ShellExecute(@WindowsDir & "\notepad.exe", @scriptdir & "\settingshelp.txt")
        Case $msg = $aboutitem
            Msgbox(0,"Delayed Capture - About",$aboutmsg)
        Case $msg = $exititem
            Exit
	EndSelect
	sleep(10)
WEnd
	
func exitprogram()
	Exit()
EndFunc

func takeScreenshots()
	$IndexValue = stringformat("%05d", $index) ;-- Appends zeros up to five characters
	$index += 1
	$FullName = $Location & $filename & $IndexValue & "." & $format
	if Not FileExists($Location) then DirCreate($Location)
	if FileExists($FullName) Then
		$index += 1
		Do
			$IndexValue = stringformat("%05d", $index) ;-- Appends zeros up to five characters
			$index += 1
			$FullName = $Location & $filename & $IndexValue & "." & $format
		Until Not FileExists($FullName)
	EndIf
	_ScreenCapture_Capture($FullName, $region[0], $region[1], $region[2], $region[3], $capturemouse)
EndFunc